<template>
  <div class="search container">
    <section class="form-preview my-5">
      <form class="form-inline form-search">
        <input v-model="query" class="form-control buscador" type="search" placeholder="Buscar..." aria-label="Search">
        <button @click.prevent="search" class="btn-big my-2 my-sm-0" type="submit">
          <i class="fas fa-search"></i>
        </button>
      </form>
    </section>
    <h2 class="text-black pb-5">Resultados para "{{this.$route.params.text}}":</h2>
    <section class="resultados" v-if="items">
      <brief v-for="item in items" v-bind:key="item.id" class="my-4" :id="item.id" :titulo="item.titulo" :url="item.imagen" :resumen="item.resumen" :fecha="item.created_at"></brief>
    </section>
    <section v-if="!items.length" class="pb-5">
      <h3 class="text-center pb-5 text-gray-dark">No hay resultados para lo que buscas 👀 ¡Prueba con otra cosa!</h3>
      <div class="text-center">
        <img src="/static/img/search.gif" alt="Search internet" class="search__img">
      </div>
    </section>
  </div>
</template>

<script>
import Vue from 'vue'
import router from '../router'
import Brief from '@/components/Brief'
export default {
  name: 'Search',
  components: {
    'brief': Brief
  },
  data () {
    return {
      items: [],
      miniquery: '',
      router: router,
      query: '',
      pag: 1
    }
  },
  mounted () {
    this.fetchData()
  },
  created: function () {
    window.addEventListener('scroll', this.handleScroll)
  },
  destroyed: function () {
    window.removeEventListener('scroll', this.handleScroll)
  },
  watch: {
    $route (data, oldData) {
      // si cambia la ruta, cambiame estos datos
      window.addEventListener('scroll', this.handleScroll)
      this.items = []
      this.pag = 1
      this.fetchData()
    }
  },
  methods: {
    search: function () {
      let tempQuery = this.query
      this.query = ''
      router.push({name: 'Search', params: { text: tempQuery }})
    },
    fetchData () {
      // Obtenemos la query
      this.miniquery = this.$route.params.text
      // Obtenemos los resultados
      Vue.http.get(`${process.env.URL_API}/api/v1/search/${this.$route.params.text}/pag/${this.pag}`).then(response => {
        console.log(response.body['message'])
        if (response.body['message']) {
          window.removeEventListener('scroll', this.handleScroll)
        } else {
          this.items = this.items.concat(response.body)
        }
      }, response => {
        // error callback
      })
    },
    handleScroll: function (event) {
      // current position
      let scrollPosition = window.pageYOffset
      // window height
      let windowSize = window.innerHeight
      // body height
      let bodyHeight = document.body.offsetHeight
      let distanceBottom = bodyHeight - windowSize - scrollPosition
      if (distanceBottom < 500) {
        this.pag += 1
        this.fetchData()
      }
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style>
</style>
